/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */

package javachan;

import gabien.IGrInDriver;
import java.util.Random;
import gabien.IGrInDriver.IImage;
import javachan.bosses.BasicBoss;
import javachan.bosses.IronheadBoss;

/**
 * As in,you could serialize this class and get a Ika.rec kind of gamestate.
 * This class is a result of a refactor involving renaming GameData and splitting it up.
 * Honestly,it was a mess.I hate long files,they are hard to navigate :)
 * @author matt
 */
public class GameState implements IPhysicsObject {
    //Note that these values are the default for when the game starts-i.e. a new GameState.
    //If you load a gamestate,or run physics,or whatever-these become null and void.
    
    //I am assuming 0=No item.
    //If that changed,tell me!
    public double InGameTime=0;
    public int[] Items=new int[10];
    public boolean[] Flags = new boolean[10000];
    public boolean BossMode=false;//During a boss,DO NOT SAVE.
    public int BossID=0;
    public double LastAnnoyTime=0;
    public int CapacitorCharge=0;
    public int CapacitorMode=-2;
    public int CapacitorTicks=0;
    public double PlayerX=40.5,PlayerY=104.5;
    public int EntityCount=0;//If >=12,Ironhead doesn't exist anymore.
    public double PlayerVX=0,PlayerVY=0;
    public int PlayerXP=0;
    public int PlayerLevel=0;
    public int PlayerEnergy=4;
    public boolean PlayerDead=false;
    public int PlayerNoDamageTicks=0;
    public int MovementTimer=0;//In ticks.
    public boolean GreatEscape=false;
    public GameStateMap map=new GameStateMap();
    public GameStateNPChar npcs=new GameStateNPChar();
    public GameStateParticles particles=new GameStateParticles();
    public BasicBoss[] Bosses=new BasicBoss[] {new IronheadBoss(0)};
    public int[] LevelXPTable={8,28,52,74,102,360,852};
    public int[] LevelEnergyTable={4,8,12,18,26,34,62};
    //NOTE:Move this to MainGame?
    private boolean SwimDebounce=false;
    
    //------------------------NO VARIABLES PAST THIS POINT. I MEAN IT. --matt
    //UTILITY
    public int GetMaxXP()
    {
        return LevelXPTable[PlayerLevel];
    }
    public int GetMaxEnergy()
    {
        return LevelEnergyTable[PlayerLevel];
    }
    public void InitGreatEscape()
    {
        PlayerVX=-0.2;
        PlayerVY=0.1;
        GreatEscape=true;
    }
    public void GreatEscapeTick()
    {
        PlayerY=PlayerY+PlayerVY;
        PlayerX=PlayerX+PlayerVX;
        
        PlayerVY-=0.0025;
        PlayerVX*=0.95;
    }
    public void MainTick(int LR,boolean SwimKey,boolean SwimKeyD,IPhysicsEngine physics,IEventCallback ev,double InGameTime)
    {
        boolean CanSwim=true;
        boolean ReleaseIsCapacitorThrust=false;
        if (PlayerNoDamageTicks>0)
        PlayerNoDamageTicks--;
        if (CapacitorTicks>0)
        {
            CapacitorTicks--;
                if (CapacitorMode==0)
                {
                PlayerVX=0;
                PlayerVY=-1/5.0;
                } else {
                PlayerVY=0;
                PlayerVX=CapacitorMode/5.0;
                }
            if (CapacitorTicks==0)
            {
                CapacitorTicks=0;
                CapacitorMode=-2;
            }
            boolean[] gaf=physics.Calculate(ev, this,this, InGameTime);
            if (gaf[0]||gaf[1]||gaf[2]||gaf[3])
            {
                CapacitorTicks=0;
                CapacitorMode=-2;
            }
            return;
        }
        if (CapacitorMode!=-2)
        {
        if (CapacitorCharge<=0)
        {
        CanSwim=false;
        ReleaseIsCapacitorThrust=true;
        } else {
            CapacitorCharge--;
        }
        }
        if (HasItem(8))
        {
            //ha ha,try to mess with me now,X window system! (X window system promptly pounds me into ground)
            if (SwimKeyD)
            {
                if (CapacitorMode==LR)
                {
                    //Well,any swimming that can happen likely has.
                    CanSwim=false;
                } else {
                    CapacitorCharge=20;
                }
            CapacitorMode=LR;
            } else {
                if (ReleaseIsCapacitorThrust)
                {
                    CapacitorTicks=40;
                } else {
                    //we released prematurely,so deactivate capacitor
                    CapacitorCharge=0;
                    CapacitorMode=-2;
                }
            }
        } else {
        //Key debouncer.Capacitor will debounce keys for us,but if there's no capacitor...
            if (SwimDebounce)
            {
                CanSwim=false;
            }
            SwimDebounce=SwimKeyD;
        }
        if (MovementTimer>0)
        {
        MovementTimer--;
        } else {
        if (SwimKey&&CanSwim)
        {
            MovementTimer=4;
                double bspd=0.04;
            switch (LR)
            {
                case 0:
                    PlayerVY-=0.05;
                    particles.AddParticle("Bubble:0", PlayerX, PlayerY+0.4, 0, bspd);
                    break;
                case -1:
                    PlayerVX-=0.05;
                    PlayerVY-=0.025;
                    particles.AddParticle("Bubble:0", PlayerX+0.4, PlayerY+0.4, bspd, bspd);
                    break;
                case 1:
                    PlayerVX+=0.05;
                    PlayerVY-=0.025;
                    particles.AddParticle("Bubble:0", PlayerX-0.4, PlayerY+0.4, -bspd, bspd);

                    break;
            }
        }
        }
        GravFric(this);
        physics.Calculate(ev, this,this, InGameTime);
    }
    public void BossesTick()
    {
        for (BasicBoss b : Bosses)
        {
            if (b.Exists(this))
            {
                b.Tick(this);
            }
        }
    }
    public void MainNPCTick(IPhysicsEngine physics,double InGameTime)
    {
        for (int x=0;x<npcs.chars.length;x++)
        {
            if (npcs.chars[x].Exists)
            {
                if (npcs.npctypes[npcs.chars[x].Type].HasPhysics())
                {
                GravFric(npcs.chars[x]);
                boolean[] bb=physics.Calculate(null,npcs.chars[x],this, InGameTime);
                npcs.chars[x].OnGround=bb[2];
                }
                npcs.npctypes[npcs.chars[x].Type].Tick(npcs.chars[x], this, InGameTime);
            }
        }
    }
    
    public boolean HasItem(int i)
    {
        for (int p=0;p<Items.length;p++)
        {
            if (Items[p]==i)
                return true;
        }
        return false;
    }
    public int CharType()
    {
        boolean spikehat=HasItem(1);
        boolean ship=HasItem(11);
        if (ship)
            return 2;
        if (spikehat)
            return 0;
        return 1;
    }
    
    public void RestoreCharacterPosition()
    {
        PlayerNoDamageTicks=0;
        PlayerX=40.5;
        PlayerY=104.5;
        PlayerVX=0;
        PlayerVY=0;
        PlayerDead=false;
        PlayerEnergy=GetMaxEnergy();
        //CharType is not affected.
        MovementTimer=0;
    }
    
    //RENDERING.Call in this order:RenderBack,Map.Render(pass 0),NPChar.Render,RenderPC,Map.Render(pass 1)
    
    public void RenderBack(int px, int py, double Time, IGrInDriver gd) {
        IImage back = gd.GetImage("Pbm/Back.pbm", 0, 0, 0);
        for (int xx = -(back.GetWidth()*2); xx <= gd.GetWidth() + back.GetWidth(); xx += back.GetWidth()) {
            boolean movement = false;
            for (int yy = -(back.GetHeight() * 2); yy <= gd.GetHeight() + (back.GetHeight() * 2); yy += back.GetHeight()) {
                movement = !movement;
                gd.BlitImage(0, 0, back.GetWidth(), back.GetHeight(), (movement ? (back.GetWidth() / 2) : 0) + (xx + ((px / 4) % back.GetWidth())), yy + ((py / 4) % back.GetWidth()), back);
            }
        }
    }
    //LR can be -1,0,or 1.
    public void RenderPC(int px, int py, int LR, IGrInDriver gd,double InGameTime) {
        IImage Ikachan = null;
        for (BasicBoss b : Bosses)
        {
            if (b.Exists(this))
            {
                b.Draw(px, py, this, gd);
            }
        }
        int CharTy=CharType();
        if (CharTy == 0) {
            Ikachan = gd.GetImage("Pbm/MyChar.pbm", 0, 0, 0);
        }
        if (CharTy == 1) {
            Ikachan = gd.GetImage("Pbm/MyChar2.pbm", 0, 0, 0);
        }
        if (CharTy == 2) {
            Ikachan = gd.GetImage("Pbm/MyChar3.pbm", 0, 0, 0);
        }
        int stateX = 0;
        int stateY = 2;
        if (LR==-1) {
            stateY = 0;
        }
        if (LR==1) {
            stateY = 1;
        }
        if (MovementTimer > 0) {
            stateX = 1;
        }
        if (CapacitorMode!=-2)
        {
            if (CapacitorMode==0)
                stateY=2;
            if (CapacitorMode==-1)
                stateY=0;
            if (CapacitorMode==1)
                stateY=1;
            //if charge complete...
            if (CapacitorCharge<=0)
            {
            stateX = 2;
            }
            //if we're actually using the capacitor,override charge...
            if (CapacitorTicks>0)
            {
            stateX = 3;
            }
        }
        if (PlayerNoDamageTicks>0)
        {
            if ((PlayerNoDamageTicks%2)==0)
                return;
        }
        if (PlayerDead) return;
        gd.BlitBCKImage(stateX * (Ikachan.GetWidth() / 4), stateY * (Ikachan.GetHeight() / 3), Ikachan.GetWidth() / 4, Ikachan.GetHeight() / 3, ((int) (PlayerX * 16) + px) - (Ikachan.GetWidth() / 8), ((int) (PlayerY * 16) + py) - (Ikachan.GetHeight() / 6), Ikachan);
    }
    
    //--------------------------------------------------------------IPhysicsObject Implementation(Player Object)

    @Override
    public double GetX() {
        return PlayerX;
    }

    @Override
    public double GetY() {
        return PlayerY;
    }

    @Override
    public double GetVX() {
        return PlayerVX;
    }

    @Override
    public double GetVY() {
        return PlayerVY;
    }

    //This is what I saved this method for.
    @Override
    public Rect GetRectangle() {
        return new Rect((int) (PlayerX * 16) - 6, (int) (PlayerY * 16) - 7, 12, 14);
    }
    

    @Override
    public void SetX(double X) {
        PlayerX=X;
    }

    @Override
    public void SetY(double Y) {
        PlayerY=Y;
    }

    @Override
    public void SetVX(double VX) {
        PlayerVX=VX;
    }

    @Override
    public void SetVY(double VY) {
        PlayerVY=VY;
    }

    public void IkachanXPEnergy(int XP,int Energy) {
        if (XP>0)
        {
            particles.AddParticle("Damage:"+XP, PlayerX, PlayerY, 0, -0.025);
        }
        PlayerXP+=XP;
        int maxxp=GetMaxXP();
        while (PlayerXP>=maxxp)
        {
            particles.AddParticle("LevelUp:0", PlayerX, PlayerY, 0, -0.025);
            PlayerXP-=maxxp;
            if (PlayerLevel!=LevelXPTable.length-1)
            {
            PlayerLevel++;
            }
            maxxp=GetMaxXP();
        }
        if (Energy<0)
        {
            if (PlayerNoDamageTicks>0)
            {
                return;
            }
            particles.AddParticle("Damage:"+Energy, PlayerX, PlayerY, 0, -0.025);
            PlayerNoDamageTicks=80;
        }
        PlayerEnergy+=Energy;
        if (PlayerEnergy>GetMaxEnergy()) PlayerEnergy=GetMaxEnergy();
        if (PlayerEnergy<=0)
        {
            PlayerEnergy=0;
            PlayerDead=true;
            Random r=new Random();
            for (int px=0;px<16;px++)
            {
                particles.AddParticle("Star:0", PlayerX, PlayerY, (r.nextDouble()-0.5)/16.0, (r.nextDouble()-0.5)/16.0);
            }
        }
    }

    private void GravFric(IPhysicsObject op) {
        op.SetVY(op.GetVY()+0.0025);
        double d=op.GetVX();
        boolean sign=d<0;
        if (sign) d=-d;
        d-=d*0.025;
        op.SetVX(d*(sign?-1:1));
    }
}
