/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games.editorui;

import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class UIHorizontalList extends UIPanel {

    public static interface ListEntry {
        public boolean IsEqualTo(ListEntry le);
        public void Draw(int centerx,int centery,double DeltaTime,IGrInDriver igd);
    }
    public int SelectedItem=0;
    public Runnable OnChange;
    public UIHorizontalList()
    {
        super();
        Elements.add(SCROLLBAR);
    }
    public UIScrollbar SCROLLBAR=new UIScrollbar();
    public int ScrollbarScale=4;
    public ListEntry[] Types=null;

    @Override
    public void UpdateAndDraw(int ox, int oy, double DeltaTime, boolean selected, IGrInDriver igd) {
        //UINPCTYPES LAYOUT CODE
        int roomneeded=Types.length;
        roomneeded-=(Bounds.width/32);
        if (roomneeded<0) roomneeded=0;
        SCROLLBAR.SetBounds(new Rect(0,Bounds.height-16,(roomneeded*ScrollbarScale)+16,16));
        //--END UINPCTYPES LAYOUT CODE
            IImage edit=igd.GetImage("TileEditor.png", 0, 0, 0);
        for (int px=0;px<Bounds.width;px+=32)
        {
            int remaining=Bounds.width-px;
            if (remaining>32) remaining=32;
            igd.BlitImage(224, 0, remaining, 16, ox+px, oy+0, edit);
            igd.BlitImage(224, 0, remaining, 16, ox+px, oy+16, edit);
            igd.BlitImage(224, 0, remaining, 32, ox+px, oy+32, edit);
        }
        for (int p=0;p<Bounds.width/32;p++)
        {
            int i=p+(SCROLLBAR.Value/ScrollbarScale);
            if (i>=Types.length) break;
            if (i<0) continue;
            if (i==SelectedItem)
            {
            igd.BlitImage(256, 0, 32, 16, (32*p)+ox, 0, edit);
            igd.BlitImage(256, 0, 32, 16, (32*p)+ox, 16, edit);
            igd.BlitImage(256, 0, 32, 32, (32*p)+ox, 32, edit);
            }
            Types[i].Draw(ox+16+(32*p), oy+24, DeltaTime, igd);
        }
        super.UpdateAndDraw(ox, oy, DeltaTime, selected, igd);
    }
    @Override
    public void HandleClick(int x, int y) {
        if (y<Bounds.height-16)
        {
            int i=(x/32)+(SCROLLBAR.Value/ScrollbarScale);
            if (i<0)
                return;
            if (i>=Types.length)
                return;
            SelectedItem=i;
            OnChange.run();
            return;
        }
        super.HandleClick(x,y);
    }

}
