/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class AttackStarNPCType extends BasicNPCType {

    @Override
    public boolean HasPhysics() {
        return true;
    }
    @Override
    public void Draw(int px,int py,double Time,GameStateNPChar.NPCCharacter In,GameState gs,IGrInDriver graphics)
    {
        int LR = 2;
        if (gs.PlayerX < In.X) {
            LR = 0;
        }
        if (gs.PlayerX > In.X) {
            LR = 1;
        }
        IImage npci=graphics.GetImage("Pbm/Hoshi.pbm", 0, 0, 0);
        int xx=0;
        int yy=0;
        int ww=16;
        int hh=16;
        int ox=0;
        int oy=0;
        xx=LR*16;
        yy=0;//TODO:Hoshi Animation //yy=(In.Status2<=1)?16:0;
        if (npci==null)
        {
            System.out.println("MISSING IMAGE FOR ("+getClass().getName()+")");
        } else{
            graphics.BlitBCKImage(xx, yy, ww, hh, (int) (In.X * 16) + px + ox, (int) (In.Y * 16) + py + oy, npci);
        }
    }

    @Override
    public void Tick(NPCCharacter npc, GameState gs, double Time) {
        int LR = 0;
        if (gs.PlayerX < npc.X) {
            LR = -1;
        }
        if (gs.PlayerX > npc.X) {
            LR = 1;
        }
        Rect ta=new Rect((int)(npc.X*16),0,16,1);
        Rect tb=new Rect((int)(gs.PlayerX*16)-8,0,16,1);
        //I just replayed the Attack star battle.
        //Important things to note:
        //They are,as suspected,entirely in control of velocity.
        //(unlike Ikachan,who can only thrust to move about)
        double TV=0.3;
        if (!ta.intersects(tb))
        {
        if (LR==-1)
        npc.VX-=TV/80;//terminal velocity/1 second(apparently)
        if (LR==1)
        npc.VX+=TV/80;
        }
        if (npc.VX>TV) npc.VX=TV;
        if (npc.VX<-TV) npc.VX=-TV;
        if (npc.Y<gs.PlayerY)
        {
            //we're higher up.
        } else {
            //we're lower down.
            npc.VY-=0.01;//custom velocity due to gravity,and such.if the Gravity constant is changed,
                         //have fun testing this.
            if (npc.VY<-TV) npc.VY=-TV;
        }
    }
    @Override
    protected int Damage()
    {
        return 2;
    }
    @Override
    protected int LevelToHurt()
    {
        return 2;
    }
    @Override
    protected int XP()
    {
        return 3;
    }
}
