/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class SleepNPCType extends BasicNPCType {
    @Override
    public boolean HasPhysics()
    {
        return false;
    }
    @Override
    public Rect GetRectangle(GameStateNPChar.NPCCharacter In)
    {
        return new Rect((int)(In.X*16)+3,(int)(In.Y*16)+6,10,10);
    }    
    @Override
    public void Tick(NPCCharacter npc, GameState gs, double Time) {
        boolean in=new Rect((int)(npc.X*16)-16,(int)(npc.Y*16)-16,48,48).contains((int)(gs.GetX()*16), (int)(gs.GetY()*16));
        if (in)
        {
            if (npc.Status2<12)
            npc.Status2++;
        } else {
            if (npc.Status2>0)
            npc.Status2--;
        }
    }    
    @Override
    public void Draw(int px,int py,double Time,GameStateNPChar.NPCCharacter In,GameState gs,IGrInDriver graphics)
    {
        IImage npci=graphics.GetImage("Pbm/Sleep.pbm", 0, 0, 0);
        int s=(In.Status2/3)-1;
        if (s<0) s=0;
        int xx=(s%2)==1 ? (npci.GetWidth()/2):0;
        int yy=(s/2)==1 ? (npci.GetHeight()/2):0;
        int ww=npci.GetWidth()/2;
        int hh=npci.GetHeight()/2;
        int ox=8-(npci.GetWidth()/4);
        int oy=-((npci.GetHeight()/2)-16);
        if (npci==null)
        {
        	//Supposedly,this is "dead code".Yeah,I don't believe it either
            System.out.println("MISSING IMAGE FOR ("+getClass().getName()+")");
        } else{
            graphics.BlitBCKImage(xx, yy, ww, hh, (int) (In.X * 16) + px + ox, (int) (In.Y * 16) + py + oy, npci);
        }
    }
}
